{-# LANGUAGE ForeignFunctionInterface #-}
module HROOT.Graf.TBRIK.FFI where
import Foreign.C
import Foreign.Ptr
import HROOT.Graf.TBRIK.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_SetName"
               c_tbrik_setname :: Ptr RawTBRIK -> CString -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_SetNameTitle"
               c_tbrik_setnametitle :: Ptr RawTBRIK -> CString -> CString -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_SetTitle"
               c_tbrik_settitle :: Ptr RawTBRIK -> CString -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_GetLineColor"
               c_tbrik_getlinecolor :: Ptr RawTBRIK -> IO CInt

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_GetLineStyle"
               c_tbrik_getlinestyle :: Ptr RawTBRIK -> IO CInt

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_GetLineWidth"
               c_tbrik_getlinewidth :: Ptr RawTBRIK -> IO CInt

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_ResetAttLine"
               c_tbrik_resetattline :: Ptr RawTBRIK -> CString -> IO ()

foreign import ccall safe
               "HROOTGrafTBRIK.h TBRIK_SetLineAttributes"
               c_tbrik_setlineattributes :: Ptr RawTBRIK -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_SetLineColor"
               c_tbrik_setlinecolor :: Ptr RawTBRIK -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_SetLineStyle"
               c_tbrik_setlinestyle :: Ptr RawTBRIK -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_SetLineWidth"
               c_tbrik_setlinewidth :: Ptr RawTBRIK -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_SetFillColor"
               c_tbrik_setfillcolor :: Ptr RawTBRIK -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_SetFillStyle"
               c_tbrik_setfillstyle :: Ptr RawTBRIK -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_Draw"
               c_tbrik_draw :: Ptr RawTBRIK -> CString -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_FindObject"
               c_tbrik_findobject ::
               Ptr RawTBRIK -> CString -> IO (Ptr RawTObject)

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_GetName"
               c_tbrik_getname :: Ptr RawTBRIK -> IO CString

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_IsA" c_tbrik_isa
               :: Ptr RawTBRIK -> IO (Ptr RawTClass)

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_Paint"
               c_tbrik_paint :: Ptr RawTBRIK -> CString -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_printObj"
               c_tbrik_printobj :: Ptr RawTBRIK -> CString -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_SaveAs"
               c_tbrik_saveas :: Ptr RawTBRIK -> CString -> CString -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_Write"
               c_tbrik_write :: Ptr RawTBRIK -> CString -> CInt -> CInt -> IO CInt

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_delete"
               c_tbrik_delete :: Ptr RawTBRIK -> IO ()

foreign import ccall safe "HROOTGrafTBRIK.h TBRIK_newTBRIK"
               c_tbrik_newtbrik ::
               CString ->
                 CString ->
                   CString -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTBRIK)
