{-# LANGUAGE ForeignFunctionInterface #-}
module HROOT.Graf.TCanvas.FFI where
import Foreign.C
import Foreign.Ptr
import HROOT.Graf.TCanvas.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_cd"
               c_tcanvas_cd :: Ptr RawTCanvas -> CInt -> IO (Ptr RawTCanvas)

foreign import ccall safe
               "HROOTGrafTCanvas.h TCanvas_divide_tvirtualpad"
               c_tcanvas_divide_tvirtualpad ::
               Ptr RawTCanvas ->
                 CInt -> CInt -> CDouble -> CDouble -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_SetLogx"
               c_tcanvas_setlogx :: Ptr RawTCanvas -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_SetLogy"
               c_tcanvas_setlogy :: Ptr RawTCanvas -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_SetLogz"
               c_tcanvas_setlogz :: Ptr RawTCanvas -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_Draw"
               c_tcanvas_draw :: Ptr RawTCanvas -> CString -> IO ()

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_FindObject"
               c_tcanvas_findobject ::
               Ptr RawTCanvas -> CString -> IO (Ptr RawTObject)

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_GetName"
               c_tcanvas_getname :: Ptr RawTCanvas -> IO CString

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_IsA"
               c_tcanvas_isa :: Ptr RawTCanvas -> IO (Ptr RawTClass)

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_Paint"
               c_tcanvas_paint :: Ptr RawTCanvas -> CString -> IO ()

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_printObj"
               c_tcanvas_printobj :: Ptr RawTCanvas -> CString -> IO ()

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_SaveAs"
               c_tcanvas_saveas :: Ptr RawTCanvas -> CString -> CString -> IO ()

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_Write"
               c_tcanvas_write ::
               Ptr RawTCanvas -> CString -> CInt -> CInt -> IO CInt

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_delete"
               c_tcanvas_delete :: Ptr RawTCanvas -> IO ()

foreign import ccall safe "HROOTGrafTCanvas.h TCanvas_newTCanvas"
               c_tcanvas_newtcanvas ::
               CString -> CString -> CInt -> CInt -> IO (Ptr RawTCanvas)
