{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Graf.TCrown.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Graf.TCrown.RawType
import HROOT.Graf.TCrown.FFI
import HROOT.Graf.TCrown.Interface
import HROOT.Graf.TCrown.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Graf.TEllipse.RawType
import HROOT.Graf.TEllipse.Cast
import HROOT.Graf.TEllipse.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITCrown TCrown

instance ITEllipse TCrown

instance ITObject TCrown where
        draw = xform1 c_tcrown_draw
        findObject = xform1 c_tcrown_findobject
        getName = xform0 c_tcrown_getname
        isA = xform0 c_tcrown_isa
        paint = xform1 c_tcrown_paint
        printObj = xform1 c_tcrown_printobj
        saveAs = xform2 c_tcrown_saveas
        write = xform3 c_tcrown_write

instance ITAttLine TCrown where
        getLineColor = xform0 c_tcrown_getlinecolor
        getLineStyle = xform0 c_tcrown_getlinestyle
        getLineWidth = xform0 c_tcrown_getlinewidth
        resetAttLine = xform1 c_tcrown_resetattline
        setLineAttributes = xform0 c_tcrown_setlineattributes
        setLineColor = xform1 c_tcrown_setlinecolor
        setLineStyle = xform1 c_tcrown_setlinestyle
        setLineWidth = xform1 c_tcrown_setlinewidth

instance ITAttFill TCrown where
        setFillColor = xform1 c_tcrown_setfillcolor
        setFillStyle = xform1 c_tcrown_setfillstyle

instance IDeletable TCrown where
        delete = xform0 c_tcrown_delete

newTCrown ::
            CDouble ->
              CDouble -> CDouble -> CDouble -> CDouble -> CDouble -> IO TCrown
newTCrown = xform5 c_tcrown_newtcrown
