{-# LANGUAGE ForeignFunctionInterface #-}
module HROOT.Graf.TEllipse.FFI where
import Foreign.C
import Foreign.Ptr
import HROOT.Graf.TEllipse.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType

foreign import ccall safe "HROOTGrafTEllipse.h TEllipse_Draw"
               c_tellipse_draw :: Ptr RawTEllipse -> CString -> IO ()

foreign import ccall safe "HROOTGrafTEllipse.h TEllipse_FindObject"
               c_tellipse_findobject ::
               Ptr RawTEllipse -> CString -> IO (Ptr RawTObject)

foreign import ccall safe "HROOTGrafTEllipse.h TEllipse_GetName"
               c_tellipse_getname :: Ptr RawTEllipse -> IO CString

foreign import ccall safe "HROOTGrafTEllipse.h TEllipse_IsA"
               c_tellipse_isa :: Ptr RawTEllipse -> IO (Ptr RawTClass)

foreign import ccall safe "HROOTGrafTEllipse.h TEllipse_Paint"
               c_tellipse_paint :: Ptr RawTEllipse -> CString -> IO ()

foreign import ccall safe "HROOTGrafTEllipse.h TEllipse_printObj"
               c_tellipse_printobj :: Ptr RawTEllipse -> CString -> IO ()

foreign import ccall safe "HROOTGrafTEllipse.h TEllipse_SaveAs"
               c_tellipse_saveas :: Ptr RawTEllipse -> CString -> CString -> IO ()

foreign import ccall safe "HROOTGrafTEllipse.h TEllipse_Write"
               c_tellipse_write ::
               Ptr RawTEllipse -> CString -> CInt -> CInt -> IO CInt

foreign import ccall safe
               "HROOTGrafTEllipse.h TEllipse_GetLineColor" c_tellipse_getlinecolor
               :: Ptr RawTEllipse -> IO CInt

foreign import ccall safe
               "HROOTGrafTEllipse.h TEllipse_GetLineStyle" c_tellipse_getlinestyle
               :: Ptr RawTEllipse -> IO CInt

foreign import ccall safe
               "HROOTGrafTEllipse.h TEllipse_GetLineWidth" c_tellipse_getlinewidth
               :: Ptr RawTEllipse -> IO CInt

foreign import ccall safe
               "HROOTGrafTEllipse.h TEllipse_ResetAttLine" c_tellipse_resetattline
               :: Ptr RawTEllipse -> CString -> IO ()

foreign import ccall safe
               "HROOTGrafTEllipse.h TEllipse_SetLineAttributes"
               c_tellipse_setlineattributes :: Ptr RawTEllipse -> IO ()

foreign import ccall safe
               "HROOTGrafTEllipse.h TEllipse_SetLineColor" c_tellipse_setlinecolor
               :: Ptr RawTEllipse -> CInt -> IO ()

foreign import ccall safe
               "HROOTGrafTEllipse.h TEllipse_SetLineStyle" c_tellipse_setlinestyle
               :: Ptr RawTEllipse -> CInt -> IO ()

foreign import ccall safe
               "HROOTGrafTEllipse.h TEllipse_SetLineWidth" c_tellipse_setlinewidth
               :: Ptr RawTEllipse -> CInt -> IO ()

foreign import ccall safe
               "HROOTGrafTEllipse.h TEllipse_SetFillColor" c_tellipse_setfillcolor
               :: Ptr RawTEllipse -> CInt -> IO ()

foreign import ccall safe
               "HROOTGrafTEllipse.h TEllipse_SetFillStyle" c_tellipse_setfillstyle
               :: Ptr RawTEllipse -> CInt -> IO ()

foreign import ccall safe "HROOTGrafTEllipse.h TEllipse_delete"
               c_tellipse_delete :: Ptr RawTEllipse -> IO ()

foreign import ccall safe
               "HROOTGrafTEllipse.h TEllipse_newTEllipse" c_tellipse_newtellipse
               ::
               CDouble ->
                 CDouble ->
                   CDouble ->
                     CDouble -> CDouble -> CDouble -> CDouble -> IO (Ptr RawTEllipse)
