{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Graf.TGraphPolar.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.Graf.TGraphPolar.RawType
import HROOT.Graf.TGraphPolar.FFI
import HROOT.Graf.TGraphPolar.Interface
import HROOT.Graf.TGraphPolar.Cast
import HROOT.Hist.TF1.RawType
import HROOT.Hist.TF1.Cast
import HROOT.Hist.TF1.Interface
import HROOT.Hist.TH1F.RawType
import HROOT.Hist.TH1F.Cast
import HROOT.Hist.TH1F.Interface
import HROOT.Hist.TAxis.RawType
import HROOT.Hist.TAxis.Cast
import HROOT.Hist.TAxis.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TGraphErrors.RawType
import HROOT.Hist.TGraphErrors.Cast
import HROOT.Hist.TGraphErrors.Interface
import HROOT.Hist.TGraph.RawType
import HROOT.Hist.TGraph.Cast
import HROOT.Hist.TGraph.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttMarker.RawType
import HROOT.Core.TAttMarker.Cast
import HROOT.Core.TAttMarker.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITGraphPolar TGraphPolar

instance ITGraphErrors TGraphPolar

instance ITGraph TGraphPolar where
        apply = xform1 c_tgraphpolar_apply
        chisquare = xform1 c_tgraphpolar_chisquare
        drawGraph = xform4 c_tgraphpolar_drawgraph
        drawPanelTGraph = xform0 c_tgraphpolar_drawpaneltgraph
        expand = xform2 c_tgraphpolar_expand
        fitPanelTGraph = xform0 c_tgraphpolar_fitpaneltgraph
        getCorrelationFactorTGraph
          = xform0 c_tgraphpolar_getcorrelationfactortgraph
        getCovarianceTGraph = xform0 c_tgraphpolar_getcovariancetgraph
        getMeanTGraph = xform1 c_tgraphpolar_getmeantgraph
        getRMSTGraph = xform1 c_tgraphpolar_getrmstgraph
        getErrorX = xform1 c_tgraphpolar_geterrorx
        getErrorY = xform1 c_tgraphpolar_geterrory
        getErrorXhigh = xform1 c_tgraphpolar_geterrorxhigh
        getErrorXlow = xform1 c_tgraphpolar_geterrorxlow
        getErrorYhigh = xform1 c_tgraphpolar_geterroryhigh
        getErrorYlow = xform1 c_tgraphpolar_geterrorylow
        initExpo = xform2 c_tgraphpolar_initexpo
        initGaus = xform2 c_tgraphpolar_initgaus
        initPolynom = xform2 c_tgraphpolar_initpolynom
        insertPoint = xform0 c_tgraphpolar_insertpoint
        integralTGraph = xform2 c_tgraphpolar_integraltgraph
        isEditable = xform0 c_tgraphpolar_iseditable
        isInsideTGraph = xform2 c_tgraphpolar_isinsidetgraph
        leastSquareFit = xform4 c_tgraphpolar_leastsquarefit
        paintStats = xform1 c_tgraphpolar_paintstats
        removePoint = xform1 c_tgraphpolar_removepoint
        setEditable = xform1 c_tgraphpolar_seteditable
        setHistogram = xform1 c_tgraphpolar_sethistogram
        setMaximumTGraph = xform1 c_tgraphpolar_setmaximumtgraph
        setMinimumTGraph = xform1 c_tgraphpolar_setminimumtgraph
        set = xform1 c_tgraphpolar_set
        setPoint = xform3 c_tgraphpolar_setpoint

instance ITNamed TGraphPolar where
        setName = xform1 c_tgraphpolar_setname
        setNameTitle = xform2 c_tgraphpolar_setnametitle
        setTitle = xform1 c_tgraphpolar_settitle

instance ITAttLine TGraphPolar where
        getLineColor = xform0 c_tgraphpolar_getlinecolor
        getLineStyle = xform0 c_tgraphpolar_getlinestyle
        getLineWidth = xform0 c_tgraphpolar_getlinewidth
        resetAttLine = xform1 c_tgraphpolar_resetattline
        setLineAttributes = xform0 c_tgraphpolar_setlineattributes
        setLineColor = xform1 c_tgraphpolar_setlinecolor
        setLineStyle = xform1 c_tgraphpolar_setlinestyle
        setLineWidth = xform1 c_tgraphpolar_setlinewidth

instance ITAttFill TGraphPolar where
        setFillColor = xform1 c_tgraphpolar_setfillcolor
        setFillStyle = xform1 c_tgraphpolar_setfillstyle

instance ITAttMarker TGraphPolar where
        getMarkerColor = xform0 c_tgraphpolar_getmarkercolor
        getMarkerStyle = xform0 c_tgraphpolar_getmarkerstyle
        getMarkerSize = xform0 c_tgraphpolar_getmarkersize
        resetAttMarker = xform1 c_tgraphpolar_resetattmarker
        setMarkerAttributes = xform0 c_tgraphpolar_setmarkerattributes
        setMarkerColor = xform1 c_tgraphpolar_setmarkercolor
        setMarkerStyle = xform1 c_tgraphpolar_setmarkerstyle
        setMarkerSize = xform1 c_tgraphpolar_setmarkersize

instance ITObject TGraphPolar where
        draw = xform1 c_tgraphpolar_draw
        findObject = xform1 c_tgraphpolar_findobject
        getName = xform0 c_tgraphpolar_getname
        isA = xform0 c_tgraphpolar_isa
        paint = xform1 c_tgraphpolar_paint
        printObj = xform1 c_tgraphpolar_printobj
        saveAs = xform2 c_tgraphpolar_saveas
        write = xform3 c_tgraphpolar_write

instance IDeletable TGraphPolar where
        delete = xform0 c_tgraphpolar_delete

newTGraphPolar ::
                 CInt ->
                   (Ptr CDouble) ->
                     (Ptr CDouble) -> (Ptr CDouble) -> (Ptr CDouble) -> IO TGraphPolar
newTGraphPolar = xform4 c_tgraphpolar_newtgraphpolar
